Imports System.Data
Imports System.Data.SqlClient
Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Error(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Error
        If Not Request.QueryString("Page") Is Nothing And Not Request.QueryString("PageSet") Is Nothing Then
            Dim strResponse As StringBuilder = New StringBuilder
            strResponse.Append("<RESPONSE><VALUES><ERROR>")
            strResponse.Append("Request Cannot be completed. Please try again")
            strResponse.Append("</ERROR>")
            strResponse.Append("</VALUES></RESPONSE>")
            Response.Clear()
            Response.ContentType = "text/xml"
            Response.Write(strResponse.ToString())
            Response.End()
        Else
            lblError.InnerText = "Request Cannot be completed. Please try again"
        End If
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim intPage As Integer = 1 'Defines the Page No
        Dim intPageSet As Integer = 1 ' Defines the PageSet
        Dim intSortBy As Integer ' Defines the Index of the Column used for sorting
        Dim intRowsPerPage As Integer = 5 ' Defines the No of Rows Per Page
        Dim dt As DataTable = GetData("SELECT CustomerID, CompanyName, ContactName, ContactTitle, City FROM Customers")

        If Not Request.QueryString("Page") Is Nothing Or Not Request.QueryString("SortBy") Is Nothing Or Not Request.QueryString("PageSet") Is Nothing Then
            If Not Request.QueryString("Page") Is Nothing Then
                intPage = Convert.ToInt32(Request.QueryString("Page").Trim)
            End If
            If Not Request.QueryString("PageSet") Is Nothing Then
                intPageSet = Convert.ToInt32(Request.QueryString("PageSet").Trim)
            End If
            If Not Request.QueryString("SortBy") Is Nothing Then
                If Not Request.QueryString("SortBy").Trim() = String.Empty Then
                    Dim strSortOrder As String = "ASC"
                    If Not Request.QueryString("SortOrder") Is Nothing Then
                        If Not Request.QueryString("SortOrder").Trim() = String.Empty Then
                            strSortOrder = Request.QueryString("SortOrder").Trim
                        End If
                    End If
                    intSortBy = Convert.ToInt32(Request.QueryString("SortBy").Trim)
                    dt.DefaultView.Sort = dt.Columns(intSortBy).ColumnName & " " & strSortOrder
                End If
            End If
            Dim strResults As String = PopulateGrid(dt.DefaultView, intPage, intRowsPerPage)
            Dim strPager As String = Pager(dt.Rows.Count, intPage, intRowsPerPage, intPageSet)
            Dim strResponse As StringBuilder = New StringBuilder
            strResponse.Append("<RESPONSE><VALUES><ERROR>False</ERROR><PAGER><![CDATA[")
            strResponse.Append(strPager)
            strResponse.Append("]]></PAGER><GRID><![CDATA[")
            strResponse.Append(strResults)
            strResponse.Append("]]></GRID></VALUES></RESPONSE>")
            Response.Clear()
            Response.ContentType = "text/xml"
            Response.Write(strResponse.ToString())
            Response.End()
        Else
            dvContent.InnerHtml = PopulateGrid(dt.DefaultView, intPage, intRowsPerPage)
            dvPager.InnerHtml = Pager(dt.Rows.Count, intPage, intRowsPerPage, intPageSet)
        End If
    End Sub
    Private Function GetData(ByVal strQuery As String) As DataTable
        Dim dt As New DataTable
        Dim strConnString As String = System.Configuration.ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Dim con As New SqlConnection(strConnString)
        Dim cmd As New SqlCommand(strQuery, con)
        Dim sda As New SqlDataAdapter
        cmd.CommandType = CommandType.Text
        Try
            con.Open()
            sda.SelectCommand = cmd
            sda.Fill(dt)
        Catch ex As Exception
            Return dt
        Finally
            con.Close()
            cmd.Dispose()
            sda.Dispose()
        End Try
        Return dt
    End Function
    Private Function PopulateGrid(ByVal dv As DataView, ByVal intPageNo As Integer, ByVal intRowsPerPage As Integer) As String
        Dim strResults As New StringBuilder
        Dim intStartIndex, intEndIndex, intRowCount As Integer

        'Do the Paging Calculation

        intRowCount = dv.Count
        intStartIndex = ((intPageNo - 1) * intRowsPerPage)
        intEndIndex = (intPageNo * intRowsPerPage) - 1

        If intRowCount <= intEndIndex Then
            intEndIndex = intRowCount - 1
        End If
        strResults.Append(" <table id = 'tblContent' cellpadding = '0' cellspacing = '0'  width = '800px'>")


        For i As Integer = intStartIndex To intEndIndex
            If i Mod 2 = 0 Then
                'Edit Row
                strResults.Append("<tr class = 'rowstyle'>")
            Else
                'Alternating Rpw
                strResults.Append("<tr class = 'alternatingrowstyle'>")
            End If
            strResults.Append("<td class = 'rowcell'>")
            strResults.Append(dv.item(i)("CustomerID").ToString())
            strResults.Append("</td>")
            strResults.Append("<td class = 'rowcell'>")
            strResults.Append(dv.item(i)("CompanyName").ToString())
            strResults.Append("</td>")
            strResults.Append("<td class = 'rowcell'>")
            strResults.Append(dv.item(i)("ContactName").ToString())
            strResults.Append("</td>")
            strResults.Append("<td class = 'rowcell'>")
            strResults.Append(dv.Item(i)("ContactTitle").ToString())
            strResults.Append("</td>")
            strResults.Append("<td class = 'rowcell'>")
            strResults.Append(dv.Item(i)("City").ToString())
            strResults.Append("</td>")
            strResults.Append("</tr>")
        Next
        strResults.Append("</table>")
        Return strResults.ToString()
    End Function
    Private Function Pager(ByVal intRowCount As Integer, ByVal intPageNo As Integer, ByVal intRowsPerPage As Integer, ByVal intPageSet As Integer) As String
        Dim strResults As New StringBuilder
        Dim intPageCount As Integer
        Dim dblPageCount As Double
        dblPageCount = Convert.ToDecimal(intRowCount) / Convert.ToDecimal(intRowsPerPage)
        intPageCount = Convert.ToInt32(Math.Ceiling(dblPageCount))
        If intPageNo > intPageCount Or intPageNo < 1 Then
            intPageNo = 1
        End If
        
        Dim intStartPage, intEndPage, intPagesPerSet As Integer
        intPagesPerSet = 10
        intStartPage = ((intPageSet - 1) * intPagesPerSet) + 1
        intEndPage = intPageSet * intPagesPerSet
        If intEndPage > intPageCount Then
            intEndPage = intPageCount
        End If
        If intPageSet > 1 Then
            strResults.Append("<a href = 'javascript:;' onclick = 'PrepareRequest(")
            strResults.Append(intStartPage - intPagesPerSet)
            strResults.Append(", ")
            strResults.Append(intPageSet - 1)
            strResults.Append(")' class='pager'><<<</a>&nbsp;")
        End If

        For k As Integer = intStartPage To intEndPage
            If k = intPageNo Then
                strResults.Append("<span class='pager'>")
                strResults.Append(k)
                strResults.Append("</span>")
            Else
                strResults.Append("<a href = 'javascript:;' onclick = 'PrepareRequest(")
                strResults.Append(k)
                strResults.Append(", ")
                strResults.Append(intPageSet)
                strResults.Append(")' class='pager'>")
                strResults.Append(k)
                strResults.Append("</a>")
                Dim str As String = strResults.ToString
            End If
            strResults.Append("&nbsp;")
        Next
        If intPageCount > intEndPage Then
            strResults.Append("<a href = 'javascript:;' onclick = 'PrepareRequest(")
            strResults.Append(intEndPage + 1)
            strResults.Append(", ")
            strResults.Append(intPageSet + 1)
            strResults.Append(")' class='pager'>>>></a>")
        End If
        Return strResults.ToString()
    End Function

   
End Class
